\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{criticmarkup}[2020/11/01 Critic markup for LaTeX]

% Required packages
\RequirePackage{xcolor}
\RequirePackage{soul}
\RequirePackage{kvoptions}

% Setup various protections to allow soul to markup citations and references
\soulregister{\cite}{7}
\soulregister{\citep}{7}
\soulregister{\citet}{7}
\soulregister{\ref}{7}
\soulregister{\eqref}{7}
\soulregister{\pageref}{7}
\soulregister{\fig}{7}
\soulregister{\tab}{7}

% Color scheme based on criticmarkup.com
\definecolor{addcolor}{HTML}{00BB00}
\definecolor{delcolor}{HTML}{DD0000}
\definecolor{subcolor}{HTML}{FF8600}
\definecolor{comcolor}{HTML}{0000BB}
\definecolor{hilcolor}{HTML}{AA53A9}

% Highlighting color
\sethlcolor{yellow}

% Family name
\SetupKeyvalOptions{
    family=crmkup,
    prefix=crmkup@
}

% Process option with reviewer name \crmkup@name
\DeclareStringOption[Name]{name}[Name]
\DeclareDefaultOption{
    \PackageWarning{criticmarkup}{Unknown ‘\CurrentOption’}
}

% Process all the keyval options
\ProcessKeyvalOptions*

% Define all the critic markup commands
\newcommand{\add}[2][\crmkup@name]
{
  {\color{addcolor}{\{\textbf{[#1:]}{ }$++$#2$++$\}}}
}

\newcommand{\del}[2][\crmkup@name]
{
  {\color{delcolor}{\{\textbf{[#1:]}{ }$--$\st{#2}$--$\}}}
}

\newcommand{\sub}[3][\crmkup@name]
{
  \textcolor{subcolor}{\{\textbf{[#1:]}{ }$\sim\sim$\st{#2}$\sim>$#3$\sim\sim$\}}
}

\newcommand{\com}[2][\crmkup@name]
{
  {\color{comcolor}{\{\textbf{[#1:]}{ }$\gg$#2$\ll$\}}}
}

\newcommand{\hil}[3][\crmkup@name]
{
    {\color{hilcolor}{\{$==$\hl{#2}$==$\}}}%
    {\com[#1]{#3}}
    % \textcolor{comcolor}{\{$\gg$#3$\ll$\}}}
}

\newcommand{\mrk}[2][\crmkup@name]
{
    {\color{hilcolor}{\{\textbf{[#1:]}{ }$==$\hl{#2}$==$\}}}
}
